#define TAB  8
#if defined (__linux__)
  #define LINUX 1
  #define WINDOWS 0
#else
  #define LINUX 0
  #define WINDOWS 1
#endif
#define MAX_LINE 200
#include "gtk/gtk.h"
#include <glib.h>


/********************************************************************/
 typedef struct _Start_State   {
   int num_lesson ;
   int root_x ;
   int root_y ;
   int root_width ;
   int root_height ;
   int width_book ;
   int sens_qr ;
}Start_State ; 
/********************************************************************/
typedef struct _Prenestro {

   int npix_tot_dico[1];
   char font_dico[100];
   GdkColor Color_dico[5];
   int book_pix_size[3] ;
}Prenestro ;/** struct used to define the window sizes
	      and caracteristics*/
/********************************************************************/
typedef struct _Trf_string {
    int lenmx_str_lesson;
    char *st_lesson;//list of all the lessons
//    int nb_in_st_lesson;// remove ?
    int nb_lesson;// total number of lessons
    int lenmx_string ; /*length of strings st_dico, st_idx1, st_alias*/
//    char *st_dico;// suppress ??
    char *st_idx1;
    char *st_alias;
    char *spath_idx1;
}Trf_string;/** struct used to transfer strings **/
/********************************************************************/
typedef struct _Trf_extrm {

   int nb_line;
   int nbsup_line;
   int max_line;
   int nb_word;
   int nbsup_word;
   int max_word;
 /**  char *ss_trf;**/
}Trf_extrm ;/** struct used to transfer data between book and dictionaries windows*/
/********************************************************************/
typedef struct _Trf_klik {

   int ibb ;/* total number of calls for dictionary windows */
   int status_hbox ; /* status number of hbox_trf */	   
   GtkWidget *ClearG_Dic;  
   GtkWidget *ppbox_trf;  
   GtkWidget *pbox_trf;  
   GtkWidget *hbox_trf;
   GtkWidget  *vbox_trf[3];
   GtkWidget  *button_clear[3];
   GtkWidget  *label_word;
   GtkWidget  *button1;
   char s_klik[100]; /* number put as a character string */
   int add_posit;
   char *s_word ;/*  text of button*/
   char *s_expr ; /* chain for the full expression */
   char *s_button ;
}Trf_klik ;/** struct used to transfer data between book and dictionaries windows*/

/********************************************************************/
typedef struct _Trf_err{
   float cof1_err;//multiplicative coef of not ok interrogations
   float cof2_err;//multiplicative coef of ok interrogations
   float cof3_err;//division coef of nb of days since last interrogation
   float cof4_err;//diminution of error in case of ok interrogation
   float cof5_err;//increase of error in case of not ok interrogation
}Trf_err; 
/********************************************************************/
typedef struct _Trf_posit{
   int nb_posit;
   int nbmx_posit;
   long *posit;//position in file
   int  *elem_nevez;
   int  *QRord_posit; //order (decreasing error for posit QR)
   int  *RQord_posit; //order (decreasing error for posit RQ)
   long int *QRcum_err; // cummulative error for QR at posit
   long int *QRcum_nb; //cummulative number of QR interrogation with ok resp.
   long int *QRcum_nb0; //cummulative number of QR interrogation with ok resp.
   long int *QRcum_nok; // cummulative number of not ok responses in QR sens
   long int *QRcum_nok0; // cummulative number of not ok responses in QR sens
   long int *QR_date_ok; // date of last ok QR
   long int *QR_date_nok; // date of last not ok QR
   long int *RQcum_err; // cummulative error for RQ at posit
   long int *RQcum_nb; //cummulative number of RQ interrogations with ok resp.
   long int *RQcum_nok; // cummulative number of not ok responses in RQ sens.
   long int *RQcum_nb0;//cummulative number of RQ interrogations with ok resp.
   long int *RQcum_nok0; // cummulative number of not ok responses in RQ sens.
   long int *RQ_date_ok; // date of last ok RQ
   long int *RQ_date_nok; // date of last not ok RQ
}Trf_posit; 
/********************************************************************/
typedef struct _Trf_book{
      int active;
      int start_lesson; // is 0 if the lesson has to be started
      int state; // state 1= first Q || R ; state 2= second Q || R
      int toggle_sens_qr;
      int sens_qr; // sens_qr = 1 if question first ; = 2 if response first
      int sens_qrm; // sens_qr that was set when writing the article
//    int sens_qr_last_reg; // sens_qr that was when registering last result
      int sound ; // sound on = 1 ; sound off = 0;
      int interro_sound ;// 1 if interrogate with sound when possible
      int nb_line;//number of lines in output (book part)
      int QR_no ; //the article identity number 
      int QR_order ; //error rank article (numero of QR  depends of sens_qr)
      int nb0;
      int nb ;
      int ilesson ; /* This is the current lesson number */
      int nbt_lesson ; /* Total number of lessons */
      int ibb ;/* total number of calls for dictionary windows */
      long *posit ;
      FILE *fp; /*  The true active lesson */
      int  exfp; /* exfp=0 if fp not created exfp=1 if fp exist */
      FILE *fp_gene; /*  The file ./idx1_gene or ./idx2_gene */
      FILE *fp_idx1; /*  The file ./IDX1/idx1_lesson_name of the 
                         active lesson */
      FILE *fp_log; /*  log output file */
/*      char pages[1000];   */
      int lenmx_str_lessons ;
      char *lessons; /* adjustable string with the names of the file pages */
      int lenmx_path_of_lesson;
      char *path_of_lesson;//path of present original lesson 
 //     (without lesson name, it is used for sound)
      char *s_label ; // all the sound-button labels in the lesson
      long int *nc_label ; // position in lesson file of sound buttons.
      Trf_posit *t_posit;
      Trf_err *t_err;
      GtkStyle *style;
      GtkWidget *win_label ;
      GtkWidget *pWindow ;
      GtkWidget *hpaned ;
      GtkWidget *frame1 ;
      GtkWidget *frame2 ;
      GtkWidget *vBox1 ;
      GtkWidget *entry_book ;
      GtkWidget *scroll_page ;
      GtkWidget *scroll2_page ;
      GtkWidget *button_qr ;
      GtkWidget *button_sound ;
      GtkWidget *Button1 ;
      GtkWidget *v_page ;
      GtkWidget *v2_page, *text_view ;
      GtkWidget *lbox2[MAX_LINE+5];/* The lines onto the page */
      GtkWidget *wbutton[MAX_LINE+5];/* The written words onto the page */
      GtkWidget *separator;/* separate Question/Response */
/*      GtkWidget *clist ;  */
/*      GtkWidget *label_word[MAX_WORD];
      GtkWidget *button1[MAX_WORD];*/
      Trf_string *G_kentel;
//      Trf_Sklik *Sklik; /* Super klik pack of all the kliks */
      Trf_extrm *extrm;
}Trf_book;/** struct used to transfer data between pages of book **/
/********************************************************************/
typedef struct _Trf_classmt {
   FILE *fp_class;// a file that will be used in the classment
   FILE *fp_log;// This is the log file
   int nb_tot;
   int nb;
   int *order;// classment
   long int *value; // the values to be classed
   long int *nk_QR; // number of already known words Q-> R sense
   long int *nk_RQ; // number of already known words R-> Q sense
   int lss_words;// length max of string ss_words
   char *ss_words;// a character chain to put words into
}Trf_classmt;
/********************************************************************/




  //********************************************************************
  //********************************************************************
void LECT_FICH_QUERE (Trf_extrm *extrm,int nb0, int nb, long posit[] ,\
      GtkWidget *box1,GtkWidget *lbox2[],\
      GtkWidget *scroll_bzh,\
      Trf_string *stgs_dico,Trf_klik *klik[],\
      Trf_book *book,GtkWidget *win_book) ;
  //********************************************************************
void LENN_KENTEL(Trf_extrm *extrm,long int nc_appel, FILE *fp ,\
	GtkWidget *box1,GtkWidget *lbox2[],\
	GtkWidget *scroll_bzh,\
	Trf_string *stgs_dico,Trf_klik *klik[]);
//********************************************************************
//********************************************************************
//                  file diaou_1.c     first display functions
//
  void ON_QUIT(GtkWidget *widget, Trf_book *book);
//********************************************************************
  void cback_next_less(GtkWidget *widget,  Trf_book  *data);
//********************************************************************
  void cback_prev_less(GtkWidget *widget,  Trf_book  *data);
//********************************************************************
  void cback_clr_butt(GtkWidget *widget,  Trf_book  *data);
//********************************************************************
  void cback_redr_butt(GtkWidget *widget,  Trf_book  *data);
//********************************************************************
  void SORT_CLASSMENT( Trf_book *book);
//********************************************************************
  void VERIF_CLASSMENT( Trf_book *book);
//********************************************************************
void WHAT_QR(int jcont , char s_alias[],Trf_book *book,\
            FILE **fp,long int *add);
//********************************************************************
void DISPLAY_ARTICLE(Trf_book *book);
//********************************************************************
void   DISPLAY_QR(FILE *fp,int istate,int *tnb_line,\
     long int add,Trf_book *book);
//********************************************************************
void   DISPLAY_LINE(char *ss,int *tnb_line,int *tlblanc, Trf_book *book);
//********************************************************************
void  EXTRACT_DICO_NAME(char s_alias[],Trf_string *G_dico, \
		char s_dico[]);
//********************************************************************
  void callback_ok_nok(GtkWidget *widget, GdkEvent *event, Trf_book *book);
//********************************************************************
  void callback_togqr(GtkWidget *widget, GdkEvent *event, Trf_book *book);
//********************************************************************
  void callback_togsound(GtkWidget *widget, GdkEvent *event, Trf_book *book);
//********************************************************************
void CONFIRM0_LESSON(Trf_book *book);
//********************************************************************
void CONFIRM0_NEW_LESSON(int code,Trf_book *book);
//********************************************************************
void CONFIRM_LESSON(GdkEvent *event,Trf_book *book);
//********************************************************************
void START_PAGE_NUMBER(Start_State *S_state,Trf_book *book);
//********************************************************************
//********************************************************************
//
//                  file diaou_2.c    Combing of the lessons
//                  
//********************************************************************
long int  FCT_ERROR(Trf_err *t_err,long int nb,long int nok,long int date,\
     long int date_ok,long int date_nok);
//********************************************************************
void CALC_INDEX( FILE *fp_log,Trf_string *G_dico , Trf_posit *t_posit ); 
//********************************************************************
void IDX1_EACH_DICO( FILE *fp_log,Trf_string *G_dico,int *modif_dico) ;
//********************************************************************
void CPY_ALL_LESSONS( FILE *fp_log,Trf_string *G_lesson);
//********************************************************************
char *PATH_FROM_G_lesson(int i, Trf_string *G_dico) ;
//********************************************************************
   char *PATH_FROM_STRING_FILE(char path_file[]);
//********************************************************************
char *FILE_FROM_G_lesson(int i, Trf_string *G_dico) ;
//********************************************************************
   char *EXTRACT_SHABANG(FILE *fp);
//********************************************************************
   char *FILENAME_FROM_PATH(char path[]);
//********************************************************************
void IDX1_DICO( FILE *fp_log,FILE *fp , \
		char sfp1[],char st_alias[],FILE *fpi, \
		Trf_classmt *trf_classmt,int *nb);
//********************************************************************
void  IDX1_DICO_NONAME_LINE(long int nc,long int *ncp,long int *nbytes,\
      char **s,FILE *fp,char *st_alias, char *s1);
//********************************************************************
void STRINGS_AJUST( Trf_string *G_dico) ;
//********************************************************************
void  CLASS_OLD_WORDS(Trf_classmt *trf_classmt);
//********************************************************************
void  TAGS_EXTRACT(Trf_classmt *trf_classmt);
//********************************************************************
int TAGGED_WORD_LINE(int *i,int lssd,char *ssd,char *tag) ;
//********************************************************************
void  INIT_CUM_ERR(Trf_posit *t_posit);
//********************************************************************
void  INIT_ORDERING_POSIT(Trf_posit *t_posit);
//********************************************************************
int  RE_ORDERING_POSIT(int sens_qr,int old_ord, long int new_err,\
            Trf_posit *t_posit);
//********************************************************************
void  PLACE_IN_SERIES(long int new_err,int i1, int i2,\
         int *ord_posit, long int *cum_err, int *i0);
//********************************************************************
void  INIT_LESSON(int *ilesson, Trf_book *book);
//********************************************************************
void  INDIRECT_IDX1(FILE *fp_gene,Trf_book *book,char *ssd,int *jcont,\
       int *nbmx_posit);
//********************************************************************
int  CHECK_EXTRACT_6LINT(long int date0, char *ssd,\
              long int i_extracted[]);
//********************************************************************
int  CHECK_EXTRACT_4LINT(long int date0, char *ssd,\
              long int i_extracted[]);
//********************************************************************
void LESSON_FROM_ORDER( FILE *fp_log,Trf_string *G_dico,int i_order,\
      char *s_lesson) ;
//********************************************************************
void  TRF_IDX1_FILE(FILE *fp_log, char *s_idx1, char *s_trf);
//********************************************************************
void  NEW_WORDS_LESSON(Trf_book *book);
//********************************************************************
void  BALANCE_WORDS(Trf_book *book);
//********************************************************************
void  NEW_TAG_LESSON(char *ss_tag,Trf_book *book);
//********************************************************************
void  DICO_TAGS(Trf_book *book);
//********************************************************************
void  DISPLAY_HELP(Trf_book *book);
//********************************************************************
void  WORST_WORDS_LESSON(int code_worst,Trf_book *book);
//********************************************************************
void  COMPLETE_WORST_LESSON(int code_worst,int prev_lesson,\
                 FILE *fp_gene,Trf_book *book);
//********************************************************************
void  WORST_TAG_LESSON(char *ss_tag,Trf_book *book);
//********************************************************************
void  COMPLETE_TAG_LESSON(int prev_lesson,FILE *fp_gene,char *ss_tag,\
       Trf_book *book);
//********************************************************************
void  SORT_COMPLETE(long int err_sup,long int err_min,int nb_words,\
      int *ord_posit,long int *cum_err, Trf_book *book);
//********************************************************************
int NOTAG(char *ssd);
//********************************************************************
void IDX1_ALL_LESSONS( FILE *fp_log,Trf_string *G_lesson);
//********************************************************************
void UPDATE_IDX1_FILE( FILE *fp_log,char *scpy_lesson, char *s_idx1) ;
//********************************************************************
void SYNCHRO_IDX1( FILE *fp_log,FILE *fp , \
  char sfp1[],char st_alias[],FILE *fpi,Trf_classmt *trf_classmt1,\
	 Trf_classmt *trf_classmt2);
//********************************************************************
void SYNCHRO_IDX1_FILE( FILE *fp_log,char *scpy_lesson, char *s_idx1,\
     char *s_idx1_bis) ;
//********************************************************************
void  DIAOU_DICO(Trf_book *book);
//********************************************************************
//********************************************************************
//********************************************************************
//********************************************************************
//
//                  file diaou_3.c    Updating of idx1 files
//                  
//********************************************************************
//********************************************************************
void  VERIF_LESSON(FILE *fp_gene,Trf_book *book);
//********************************************************************
void  RECORD_LESSON( Trf_book *book);
//********************************************************************
void  CHECK_CORR_DBASE(char *s_alias,char *s_idx1, Trf_book *book);
//********************************************************************
void  CHECK_CORR_ALL_DBASE( Trf_book *book);
//********************************************************************
void  TRF_ALL_DBASE( Trf_book *book);
//********************************************************************
void  CHECK_CORR_SNG_DBASE( char *ss,Trf_book *book);
//********************************************************************
void  SYNCHRO_ALL_DBASE(char *path_synchro, Trf_book *book);
//********************************************************************
void  RAZ_LESSON( Trf_book *book);
//********************************************************************
//********************************************************************
void MERGESORT(int left0, int right0 , int num[], long int cum_err[] ) ;
//********************************************************************
void MSORT(int num[], int temp[],long int cum_err[],\
		int left, int right);
//********************************************************************
void MERGE( int num[], int temp[],long int cum_err[],\
		int left, int mid, int right);
//********************************************************************
int COMPARE_ERR(long int err1 , long int err2 ) ;
//********************************************************************
//********************************************************************
void MERGESORT_3ERR(int left0, int right0 , int num[], long int cum_err[],\
        long int nb_nok[], long int date[]) ;
//********************************************************************
void MSORT_3ERR(int num[], int temp[],long int cum_err[],\
	long int nb_nok[],long int date[],int left, int right);
//********************************************************************
void MERGE_3ERR( int num[], int temp[],long int cum_err[],\
      long int nb_nok[],long int date[],int left, int mid, int right);
//********************************************************************
int COMPARE_3ERR(long int err1 , long int err2,\
        long int nok1,long int nok2, long int date1, long int date2 ) ;
//********************************************************************
int CMP_3ERR(long int err1[4] , long int err2[4]);
//********************************************************************
int CMP_3GERR(long int err1[4] , long int err2[4]);
//********************************************************************
//********************************************************************
void MERGESORT_STG_CLASS(int left0, int right0 , int num[],char *ss_tot);
//********************************************************************
void MSORT_STG_CLASS(int num[], int temp[],char *ss_tot,\
		int left, int right);
//********************************************************************
void MERGE_STG_CLASS( int num[], int temp[],char *ss_tot,\
		int left, int mid, int right);
//********************************************************************
int   NUM_FROM_ALIAS(char *s_alias, Trf_string *G_dico) ;
//********************************************************************
char   *S_IDX1_FROM_NUM(int num, Trf_string *G_dico) ;
//********************************************************************
char   *S_ALIAS_FROM_NUM(int num, Trf_string *G_dico) ;
//********************************************************************
char   *S_LESSON_FROM_NUM(int num, Trf_string *G_lesson) ;
//********************************************************************
char   *S_CPY_LESSON_FROM_NUM(int num, Trf_string *G_lesson) ;
//********************************************************************
void   MAKE_ST_ALIAS(FILE *fp_log,Trf_string *G_lesson) ;
//********************************************************************
void MERGESORT_ABC_FILE(int left0, int right0 , long int add[],\
    FILE *fp_words ) ;
//********************************************************************
void MSORT_ABC_FILE(long int add[],long int temp[],FILE *fp_words,\
		int left, int right);
//********************************************************************
void MERGE_ABC_FILE( long int add[],long int temp[],FILE *fp_words,\
		int left, int mid, int right);
//********************************************************************
//********************************************************************
//********************************************************************
//
//                  file diaou_5.c    To read the configuration file
//                  
//********************************************************************
void      FURCH_SET(Prenestro *Caract_win,Trf_book *book, \
	Trf_string *G_dico,char *ss_font_less,char *ss_font_vocab);
//********************************************************************
void   EXTRACT_FONT_DICO(FILE *fp,char s[],int *n_fonts,char ss_fonts[]);
//********************************************************************
void    EXTRACT_FONT_NAME(int *n_fonts,int i,char s[],\
		char ss_fonts[],int *code_fin)	;
//********************************************************************
void    FILTRE_FONT_DICO(char s[],char ss_fonts[])	;
//********************************************************************
void   EXTRACT_LEVEL(FILE *fp,char s[],int nb_tobe,int param[]);
//********************************************************************
void   FLOAT_EXTRACT_LEVEL(FILE *fp,char s[],int nb_tobe,float param[]);
//********************************************************************
void   EXTRACT_COLOR(FILE *fp,char s[],GdkColor *white);
//********************************************************************
void   EXTRACT_ORDER(FILE *fp,char s[],char BFE[]);
//********************************************************************
void   EXTRACT_PAGES(FILE *fp,char s[],int *n_pages,Trf_string *book);
//********************************************************************
void   EXTRACT_WHICH_LESSONS(FILE *fp,char s[],Trf_string *G_dico);
//********************************************************************
void    EXTRACT_INPUT(int *n_pages,int i,char s[],\
		char ss_pages[],int *code_fin)	;
//********************************************************************
void    EXTRACT1_INPUT(int i,char s[],\
		Trf_string *G_dico,int *code_fin);
//********************************************************************
void    SCD(char s[], char s_file[], Trf_string *G_dico , \
		int *code_loop, int *code_fin);
//********************************************************************
void    SCD2(char s[], char s_file[], Trf_string *G_dico , \
		int *code_loop, int *code_fin);
//********************************************************************
void    EXTRACT2_INPUT(int i,char s[],\
		Trf_string *book,int *code_fin);
//********************************************************************
void    EXTRACT3_INPUT(int i,char s[],char s1[],int *code_fin);
//********************************************************************
void   CASE_ARROW(char anv_file[],int nb0_pages,int n1,int n2,int jpages);
//********************************************************************
void   EXTRACT_2NB(char anv_file[],int *n1,int *n2);
//********************************************************************
void   EXTRACT1_2NB(char anv_file[],int *n1,int *n2,int *i0, int *i1);
//********************************************************************
//void   KLASK_PAJ(int *jpage,char mem_pages[],char anv_file[]);
//********************************************************************
void   KLASK_NB_PAJ(int *nb0_pages,char mem_pages[],char anv_file[]);
//********************************************************************
void    RECUR_EXTR_ARROW(int *code_path,char *s_path,char *s_file,\
        Trf_string *G_dico);
//********************************************************************
void    ADD_TO_G_DICO(int *code_path,char *s_path,char *s_file,\
        Trf_string *G_dico);
//********************************************************************
void   EXTRACT_PATH_IDX1(FILE *fp,char s[],int *nspath,char **s_path);
//********************************************************************
void    ADD_TO_PATH_NAME(int *nspath,int i,char s[],\
		char **s_path,int *code_fin);
//********************************************************************
//********************************************************************
//********************************************************************
//********************************************************************
//                          diaou_8.c
//                   Manage the book command line
//********************************************************************
//********************************************************************
//********************************************************************
//********************************************************************
  void clean_entry_book( GtkWidget *widget, GdkEvent *event,\
		  Trf_book *book );
//********************************************************************
  void callback_entry_book( GtkWidget *widget, Trf_book *book );
//********************************************************************
int  EXTRACT_NB_FIRST_FIELD( char *ss,Trf_book *book);
//********************************************************************
//********************************************************************
//********************************************************************
//********************************************************************
//********************************************************************
//********************************************************************
//********************************************************************
//********************************************************************
//
//                  file diaou_10.c     for utilities
//********************************************************************
void DECODE_ACCENTS(char s1[] );
//********************************************************************
void DECODE1_ACCENTS(char s1[] );
//********************************************************************
void TRO_ACCENT(int *i, int *j ,char s1[] );
//********************************************************************
void RM_ACCENTS(char s1[] );
//********************************************************************
void WORK_RM_ACCENT(int *i, int *j ,char s1[] );
//********************************************************************
void WORK_ACCENT(int *i, int *nb ,char s1[] );
//********************************************************************
int POS_NALPHA(int l_dep, int l , char s[]) ;
//********************************************************************
int SPE_ALPHA_NUM(char s1 );
//********************************************************************
double DIFF_TIME_FILE(char name_file_origin[] , 
		                char name_file_derived[] );
//********************************************************************
 void   WINDOWS_DIFFTIME(double *deltat,char ss_timer[],\
		 char ss_timer1[]);
//********************************************************************
int EXTR_N_INT(int n,char *s,int i_extracted[]);
//********************************************************************
int EXTR_N_LINT(int n,char *s,long int i_extracted[]);
//********************************************************************
void EXTRACT_N_INT(int n,char *s, int i_extracted[]);
//********************************************************************
//long int aln_getline(char **ss,long int *nbytes, FILE *fp);
long int aln_getline(long int *nc,char **ss,long int *nbytes, FILE *fp);
//********************************************************************
   char *RM_PATH_FROM_STRING(char path[]);
//********************************************************************
   char *PATH_FROM_STRING(char *string);
//********************************************************************
   char *FILE_NAME_FROM_STRING(char *string);
//********************************************************************
void  RM_EXTRA_BLANCS(char *s);
//********************************************************************
void  RM_ALL_BLANCS(char *s);
//********************************************************************
void  LNB_12CHAR(long int nb,char *snb);
//********************************************************************
long int  DIFF_JOUR();
//********************************************************************
    double Julien(int an, int ms, int jr);
//********************************************************************
   double Julian(int year,int month,double day);
//********************************************************************
int copier_fichier(char const * const source,\
                   char const * const destination);
//********************************************************************
char *back_up_file(char *file_path);
//********************************************************************
int win_file(char const * const source,\
                         char const * const destination);
//********************************************************************
int new_win_file(char const * const source,\
                         char const * const destination);
//********************************************************************
void  RESIZE_STRING(int lssd, char *ss);
//********************************************************************
/*
 *
 *
 *       file diaou_11.c     for display of text in TextView
 *
 *
 */
//********************************************************************
void CLR_TEXT(Trf_book *book);
//********************************************************************
void DISPLAY_TEXT(Trf_book *book);
//********************************************************************
int PERHAPS_BUTTON(char *ss, int *i0, int *i1);
//********************************************************************
void EXTRACT_LABEL_BUTTONS\
       (long int *nc,char **ss,long int *nbytes,Trf_book *book);
//********************************************************************
void cback_button(GtkWidget *widget, Trf_book *book);
//********************************************************************
int  SEARCH_SND_FILE_NAME(char **s_sound,long int *nbyt_snd,\
       char *ss,Trf_book *book);
//********************************************************************
int WHAT_BUTTON(char *ss, Trf_book *book);
//********************************************************************
//********************************************************************
//********************************************************************
