# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include <ctype.h>
# include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <gtk/gtk.h>
#include "diaou_0.h"

/*################################################################*/
void DECODE1_ACCENTS(char s1[] )
	/***   decode accents in string s1    ***/
/*
 *    same as DECODE_ACCENT but will add unseparable space 
 *    after < and before >
 */
{
int i,j,l,ls,k,ii;
int ct ;/*  number of spaces for a tab */
char *ss,c;

l=strlen(s1);
if ( l == 0 ) return;
ii=0;
for(j=0;j < l ; ++j){
   if(s1[j] == '\t')++ii;
}/*for(j=0;j < l ; ++j){*/
ct = TAB;
if(ii != 0 ){
  ls = l + (ct-1)*ii+1;
  ss = g_malloc(ls*sizeof(char));
  j = 0 ;
  for(i=0 ; i <= l ; ++i ){
     if(s1[i] == '\t'){
	for (k = 0 ; k < ct ; ++ k){
	   *(ss+j) = ' ';
	   ++j;
	}/* for (k = 0 ; k < ct ; ++ k){*/
     }else{ /* if(s[i] == '\t'){*/
	*(ss+j) = s1[i];
	++j;
     } /* if(s[i] == '\t'){*/
  }/*  for(i=0 ; i <= l ; ++i ){*/
//     printf("ii=%d s1=%s@@@@ \n",ii,s1);
//     printf("ii=%d ss=%s@@@@ \n",ii,ss);
  strcpy(s1,ss);
//     printf("after  s1=%s@@@@ \n",s1);
  free(ss);
  l = strlen(s1);
}/*  if(ii != 0 ){*/
j=-1;
for( i =0 ; i<= l ; ++i){
   if( s1[i] != '\\' ){
       k= s1[i];
       if(k == 146 || k == -110) {/* problem of apostroph character */
	  s1[i]= 39;
	  k = 39;
       }/*if(k == 146 || k == -110) {*/
       if(k < -105){
	  if(k == -106 ) k=45;
	  if(k == -108 ) k=34;
	  if(k == -109 ) k=34;
	  if(k == -110 ) k=39;
	  if(k == -111 ) k=39;
	  s1[i] = k;
       }/*if(k < -105){*/
       if(k < 0) s1[i]= k+256; // Accentuated letters coded -128 +128
      c = s1[i];                                                                                
      ++j ;
      s1[j] = c ;
      k= (int) c;
       if(k < 0) k= k+256; // Accentuated letters coded -128 +128
//  171 = «  187 = »
//      if( i < l-1 && (c == '<' || c == 171 || c == '\"') && s1[i+1] == ' '){
      if( i < l-1 && (c == '<' || k == 171 || k == 147 || k == 34) && s1[i+1] == ' '){
         ++i; ++j ;
	 s1[j] = 160;
      }else{//if(c == '<' && i < l-1 && s1[i+1] == ' '){
       //if(i > 0 && (c == '>' || c == 187 || c == '\"' || c == '?' || 
         if(i > 0 && (c == '>' || k == 187 || k == 148 || k == 34 || c == '?' || \
	 c == '!' || c == ';' || c == ':') && s1[i-1] == ' '){
	    s1[j-1] = 160;
         }//if(c == '>' && i > 0 && s1[i-1] == ' '){
      }//if(c == '<' && i < l-1 && s1[i+1] == ' '){
   }else{/** middle of if( s1[i] != '\\' ){   **/
      if( i+2 < l ) TRO_ACCENT(&i,&j,s1) ;
   }/** end of if( s1[i] != '\\' ){   **/
	
}/***  end of  for( i =0 ; i< l ; ++i){   ***/
}/** end of void DECODE_ACCENTS(char *s1[] )   ***/
/*################################################################*/
void DECODE_ACCENTS(char s1[] )
	/***   decode accents in string s1    ***/
{
int i,j,l,ls,k,ii;
int ct ;/*  number of spaces for a tab */
char *ss;

l=strlen(s1);
if ( l == 0 ) return;
ii=0;
for(j=0;j < l ; ++j){
   if(s1[j] == '\t')++ii;
}/*for(j=0;j < l ; ++j){*/
ct = TAB;
if(ii != 0 ){
  ls = l + (ct-1)*ii+1;
  ss = g_malloc(ls*sizeof(char));
  j = 0 ;
  for(i=0 ; i <= l ; ++i ){
     if(s1[i] == '\t'){
	for (k = 0 ; k < ct ; ++ k){
	   *(ss+j) = ' ';
	   ++j;
	}/* for (k = 0 ; k < ct ; ++ k){*/
     }else{ /* if(s[i] == '\t'){*/
	*(ss+j) = s1[i];
	++j;
     } /* if(s[i] == '\t'){*/
  }/*  for(i=0 ; i <= l ; ++i ){*/
//     printf("ii=%d s1=%s@@@@ \n",ii,s1);
//     printf("ii=%d ss=%s@@@@ \n",ii,ss);
  strcpy(s1,ss);
//     printf("after  s1=%s@@@@ \n",s1);
  free(ss);
  l = strlen(s1);
}/*  if(ii != 0 ){*/
j=-1;
for( i =0 ; i<= l ; ++i){
   if( s1[i] != '\\' ){
       k= s1[i];
       if(k == 146 || k == -110) {/* problem of apostroph character */
	  s1[i]= 39;
	  k = 39;
       }/*if(k == 146 || k == -110) {*/
       if(k < -105){
	  if(k == -106 ) k=45;
	  if(k == -108 ) k=34;
	  if(k == -109 ) k=34;
	  if(k == -110 ) k=39;
	  if(k == -111 ) k=39;
	  s1[i] = k;
       }/*if(k < -105){*/
       if(k < 0) s1[i]= k+256; // Accentuated letters coded -128 +128
      ++j ;
      s1[j] = s1[i] ;
   }else{/** middle of if( s1[i] != '\\' ){   **/
      if( i+2 < l ) TRO_ACCENT(&i,&j,s1) ;
   }/** end of if( s1[i] != '\\' ){   **/
	
}/***  end of  for( i =0 ; i< l ; ++i){   ***/
}/** end of void DECODE_ACCENTS(char *s1[] )   ***/
/*################################################################*/
void TRO_ACCENT(int *i, int *j ,char s1[] )
	/***   translation of accents according to code   ***/
	/**   \'e \`e \`a   .....     ***/
	/***   s1[i] = \     **/
{
int i1,i2,j1 ;

   i1= *i+1;
   i2=i1+1;	   
   if(s1[i1] == '~'){
        if(s1[i2]== 'n'){
	   *j = *j+1;
	   s1[*j] = 241 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i2]== 'N'){
	   *j = *j+1;
	   s1[*j] = 209 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/** end of if(s1[i1] == '~'){ **/
   if(s1[i2] == 'a'){
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 224 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 228 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '~'){
	   *j = *j+1;
	   s1[*j] = 227 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '\''){
	   *j = *j+1;
	   s1[*j] = 225 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 226 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'a'){  **/
   if(s1[i2] == 'e'){
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 232 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 234 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '\''){
	   *j = *j+1;
	   s1[*j] = 233 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 235 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== 'a'){/***   OK for ae   ***/
	   *j = *j+1;
	   s1[*j] = 230 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== 'o'){ /***  sorry not possible for oe ****/
	   *j = *j+1;
	   s1[*j] = 'o' ;
	   *j = *j+1;
	   s1[*j] = 'e' ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'e'){  **/
   if(s1[i2] == 'i'){
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 239 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 238 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'u'){
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 252 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 251 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 249 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'o'){
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 244 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 246 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'c'){
        if(s1[i1]== ','){
	   *j = *j+1;
	   s1[*j] = 231 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
                 /**/
    /**  Now for capital letters  **/
   if(s1[i1] == '~'){
        if(s1[i2]== 'N'){
	   *j = *j+1;
	   s1[*j] = 209 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i2]== 'N'){
	   *j = *j+1;
	   s1[*j] = 209 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/** end of if(s1[i1] == '~'){ **/
   if(s1[i2] == 'A'){
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 192 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 194 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'a'){  **/
   if(s1[i2] == 'E'){
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 200 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 202 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '\''){
	   *j = *j+1;
	   s1[*j] = 201 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 203 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== 'A'){/***   OK for ae   ***/
	   *j = *j+1;
	   s1[*j] = 198 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== 'O'){ /***  sorry not possible for oe ****/
	   *j = *j+1;
	   s1[*j] = 'O' ;
	   *j = *j+1;
	   s1[*j] = 'E' ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'e'){  **/
   if(s1[i2] == 'I'){
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 207 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 206 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'U'){
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 220 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 219 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== '`'){
	   *j = *j+1;
	   s1[*j] = 217 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'O'){
        if(s1[i1]== '^'){
	   *j = *j+1;
	   s1[*j] = 212 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
        if(s1[i1]== ':'){
	   *j = *j+1;
	   s1[*j] = 214 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   if(s1[i2] == 'C'){
        if(s1[i1]== ','){
	   *j = *j+1;
	   s1[*j] = 199 ;
	   *i = i2 ;
	   return ;
	}/** end of if(s1[i2]== 'n'){  ***/
   }/**  end of if(s1[i2] == 'i'){  **/
   *j = *j +1 ;
   j1 = *j ;
   s1[j1] = s1[*i] ;
   *i = *i +1 ;

}/** end of void TRO_ACCENT(int *i, int *j ,char s1[] )   ***/
/*################################################################*/
void RM_ACCENTS(char s1[] )
	/***   remove all the accents in string s1    ***/
	/***   this is useful to search the indexes   ***/
{
int i,j,l,nb,ijump;
char k ;

l=strlen(s1);
/*printf("entree RM_ACCENTS l=%d s1=%s \n",l,s1);*/
if ( l == 0 ) return;
j=-1;
nb=0;
for( i =0 ; i<= l ; ++i){
   if( s1[i] != '\\' ){
      WORK_ACCENT(&i,&nb,s1);
      ++j ;
      s1[j] = s1[i] ;
   }else{/** middle of if( s1[i] != '\\' ){   **/
      if( i+2 < l ) WORK_RM_ACCENT(&i,&j,s1) ;
   }/** end of if( s1[i] != '\\' ){   **/
}/***  end of  for( i =0 ; i< l ; ++i){   ***/
++j;
s1[j]='\0';
/*printf("sortie RM_ACCENTS nb=%d j=%d s1=%s \n",nb,j,s1);*/
if(nb == 0 )return;
/*
 *   We now have to remove ae and AE 8 bits coding
 */
   i=j+nb;
   while(j >= 0){
      ijump=0;
      k=230;
      if( s1[j] == k){
	 s1[i]='e';
	 --i;
	 s1[i]='a';
	 ijump=1 ;
      }/*if( s1[j] == 230){*/
      k=198;
      if( s1[j] == k && ijump == 0){
	 s1[i]='E';
	 --i;
	 s1[i]='A';
	 ijump=1 ;
      }/*if( s1[j] == 230){*/
      --i;
      --j;
   }/*   end of while(j >= 0){   */
}/** end of void RM_ACCENTS(char *s1[] )   ***/
/*################################################################*/
void WORK_RM_ACCENT(int *i, int *j ,char s1[] )
	/***  Remove the accents of accentuated lettrers        ***/
	/**   \'e /`e /`a   .....     ***/
	/***   s1[i] = \     **/
{
int i1,i2,j1 ;

   i1= *i+1;
   i2=i1+1;	   
   if(s1[i1] == '~' || s1[i1] == '`' || s1[i1] == '^' || s1[i1] == '\'' \
	      || s1[i1] == ':' || s1[i1] == ','){
	   *j = *j+1;
	   s1[*j] = s1[i2];
	   *i = i2 ;
	   return ;
   }/** end of if(s1[i1] == '~'){ **/
   if(s1[i1] == 'a' && s1[i2] == 'e'){
	   *j = *j+1;
	   s1[*j] = s1[i1];
	   *j = *j+1;
	   s1[*j] = s1[i2];
	   *i = i2 ;
	   return ;
   }/* end of if(s1[i1] == 'a' && s1[i2] == 'e'){  */
   if(s1[i1] == 'A' && s1[i2] == 'E'){
	   *j = *j+1;
	   s1[*j] = s1[i1];
	   *j = *j+1;
	   s1[*j] = s1[i2];
	   *i = i2 ;
	   return ;
   }/* end of if(s1[i1] == 'a' && s1[i2] == 'e'){  */
   if(s1[i1] == 'o' && s1[i2] == 'e'){
	   *j = *j+1;
	   s1[*j] = s1[i1];
	   *j = *j+1;
	   s1[*j] = s1[i2];
	   *i = i2 ;
	   return ;
   }/* end of if(s1[i1] == 'a' && s1[i2] == 'e'){  */
   if(s1[i1] == 'O' && s1[i2] == 'E'){
	   *j = *j+1;
	   s1[*j] = s1[i1];
	   *j = *j+1;
	   s1[*j] = s1[i2];
	   *i = i2 ;
	   return ;
   }/* end of if(s1[i1] == 'a' && s1[i2] == 'e'){  */


   *j = *j +1 ;
   j1 = *j ;
   s1[j1] = s1[*i] ;
   *i = *i +1 ;

}/** end of void TRO_ACCENT(int *i, int *j ,char s1[] )   ***/
/*################################################################*/
void WORK_ACCENT(int *i, int *nb ,char s1[] )
	/***  Remove the accents of accentuated lettrers        ***/
	/*   The accentuated letters are given by a single
	 *   8 bits code
	 */
	/**   \'e /`e /`a   .....     ***/
{
char kc;
int k;

kc=s1[*i];
k = kc;
/*printf("WORK_ACCENT i=%d kc=%c k=%d \n",*i,kc,k);*/
if(k < 0)k=k+256;
if(k < 198)return ;
if(k == 241){
   s1[*i] = 'n';
   return ;
}/*if(s1[i] == 241){*/
if(k == 231){
   s1[*i] = 'c';
   return ;
}/*if(s1[i] == 241){*/
if(k == 199){
   s1[*i] = 'C';
   return ;
}/*if(s1[i] == 241){*/
if(k == 209){
   s1[*i] = 'N';
   return ;
}/*if(s1[i] == 241){*/
if(k >= 224 && k <= 229){
   s1[*i] = 'a';
   return ;
}/*if(s1[i] == 241){*/
/*if(k == 226){
   s1[*i] = 'a';
   return ;
}*//*if(s1[i] == 241){*/
if(k == 232 || k == 234 || k == 233 || k == 235){
   s1[*i] = 'e';
   return ;
}/*if(s1[i] == 241){*/
if(k == 238 || k == 239 ){
   s1[*i] = 'i';
   return ;
}/*if(s1[i] == 241){*/
if(k == 206 || k == 207 ){
   s1[*i] = 'I';
   return ;
}/*if(s1[i] == 241){*/
if(k == 249 || k == 251 || k == 252){
   s1[*i] = 'u';
   return ;
}/*if(s1[i] == 241){*/
if(k == 217 || k == 219 || k == 220){
   s1[*i] = 'U';
   return ;
}/*if(s1[i] == 241){*/
if(k == 244 || k == 246 ){
   s1[*i] = 'o';
   return ;
}/*if(s1[i] == 241){*/
if(k == 212 || k == 214 ){
   s1[*i] = 'O';
   return ;
}/*if(s1[i] == 241){*/
if(k == 192 || k == 194 ){
   s1[*i] = 'A';
   return ;
}/*if(s1[i] == 241){*/
if(k == 200 || k == 201 || k == 202 || k == 203){
   s1[*i] = 'E';
   return ;
}/*if(s1[i] == 241){*/
if(k == 230){/*  code ae  */
   *nb = *nb + 1;
   return ;
}/*if(s1[i] == 241){*/
if(k == 198){/*  code AE  */
   *nb = *nb + 1;
   return ;
}/*if(s1[i] == 241){*/
/*
 *    Remark  codes oe and OE are unknown to me
 */
 

}/** end of void WORK_ACCENT(int *i, int *j ,char s1[] )   ***/
/*################################################################*/
int POS_NALPHA(int l_dep, int l , char s[]) 
{
int i;

i=l_dep ;
//  printf("POS_NALPHA ");
while(i <=l ){
   if(!SPE_ALPHA_NUM(s[i]) && s[i] != ' ')return(i);
//   printf("%c",s[i]);
   ++i;
}/** end of while(i <=l && icode == 0){  **/
// printf("\n ");
return (i);
}/** end of POS_NALPHA  **/
/*################################################################*/
int SPE_ALPHA_NUM(char s1 )
/*
 *   Subroutine to detect special alphanumeric characters 
 *   which may be used into words. So we have also the
 *   accentuated letters. If s1 is acceptable, then 1 is
 *   returned.
 */ 
{
int k,rtn;

rtn = 1 ;
k = s1;
/*if(isalnum(s1)  || s1 =='-' \
   	 || s1 =='\'' || s1 == '\\'){*/
/*  for  WINDOWS only */
if((k >= 'a' && k <= 'z') || (k >= 'A' && k <= 'Z') \
		|| (k >= '0' && k <= '9')|| s1 =='-' \
   	 || s1 =='\'' || s1 == '\\'){
   return(rtn);
}
if(k < 0)k=k+256;
if(k == 241){
/*   s1[*i] = 'n';*/
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 231){
/*   s1[*i] = 'c';*/
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 199){
 /*  s1[*i] = 'C';*/
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 209){
/*   s1[*i] = 'N';   */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k >= 224 && k <= 229){
/*   s1[*i] = 'a';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 232 || k == 234 || k == 233 || k == 235){
/*   s1[*i] = 'e';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 238 || k == 239 ){
/*   s1[*i] = 'i';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 206 || k == 207 ){
/*   s1[*i] = 'I';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 249 || k == 251 || k == 252){
/*   s1[*i] = 'u';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 217 || k == 219 || k == 220){
/*   s1[*i] = 'U';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 244 || k == 246 ){
/*   s1[*i] = 'o';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 212 || k == 214 ){
/*   s1[*i] = 'O';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 192 || k == 194 ){
/*   s1[*i] = 'A';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 200 || k == 201 || k == 202 || k == 203){
/*   s1[*i] = 'E';  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
if(k == 230){/*  code ae  */
/*   *nb = *nb + 1;  */
   return(rtn) ;  
}/*if(s1[i] == 241){*/
if(k == 198){/*  code AE  */
/*   *nb = *nb + 1;  */
   return(rtn) ;
}/*if(s1[i] == 241){*/
/*
 *    Remark  codes oe and OE are unknown to me
 */
rtn = 0 ;
return(rtn) ;
 

}/** end of void WORK_ACCENT(int *i, int *j ,char s1[] )   ***/
/*################################################################*/
double DIFF_TIME_FILE(char name_file_origin[] , 
		                char name_file_derived[] )
/*
 *   Compute the difference between the time of last modification
 *   of two files given by their name . On return we have 
 *   deltat = time(name_file_derived) - time(name_file_origin)
 *   if deltat > 0  file_derived is younger than file_origin
 *   if file_origin does not exist the program stops. If file_derived
 *   does not exists deltat = -1 and a warning is printed
 */
{
   int i;	
   struct stat *stat_file ;
   time_t timer1, timer;
   double deltat;
   char ss[50],s_timer[50],s_timer1[50];

   stat_file = g_malloc(sizeof(struct stat));
/*   printf("sizeof=%d \n",sizeof(struct stat));
   printf("enter DIFF_TIME_FILE \n");
   printf("file_origin=%s@@@\n",name_file_origin);
   printf("file_derived=%s@@@\n",name_file_derived);*/
   
   i = stat(name_file_origin,stat_file);
   if( i >= 0){
//      printf("i=%d \n",i);
      timer1 = (*stat_file).st_mtime ;
      sprintf(s_timer1,"%s",asctime(localtime(&timer1)));
      printf("time of last modif %s = %s. \n",name_file_origin, \
		      s_timer1);
   }else{/* if(stat_file != NULL){*/
      printf("Error file %s  does not exist stop \n",name_file_origin);
      exit(1);
   }/* if(stat_file != NULL){*/
    
   i = stat(name_file_derived,stat_file);
   if(i >= 0){
//      printf("i=%d \n",i);
      timer = (*stat_file).st_mtime ;
      sprintf(s_timer,"%s",asctime(localtime(&timer)));
      printf("time of last modif %s = %s. \n", name_file_derived,\
		      s_timer);
      deltat = difftime(timer,timer1);
      sprintf(ss,"%e",deltat);
//      if(strstr(ss,"IND") != NULL) WINDOWS_DIFFTIME(&deltat,ss_timer,
//		      ss_timer1);
      WINDOWS_DIFFTIME(&deltat,s_timer, s_timer1);
      printf("after WINDOWS_DIFFTIME deltat=%e \n",deltat);

   }else{/* if(timer == NULL){*/
           printf("you need to create %s \n",name_file_derived);
	   deltat = -1;
   }/* if(timer == NULL){*/
   printf("diff time= %e \n",deltat);
   free( stat_file);
   return(deltat);
   }/* end of double DIFF_TIME_FILE  */ 
/*################################################################*/
 void   WINDOWS_DIFFTIME(double *deltat,char ss_timer[],\
		 char ss_timer1[])
/*  
 *    This sub has been introduced because under WINDOWS, the difftime
 *    function occasionaly does not work well ...
 *    We don't have here a true difftime. We return
 *               +1 if   timer younger than timer1
 *               0  if   timer = timer1
 *               -1 if   timer older than timer1
 *
 *           DDD MMM dd hh:mm:ss YYYY
 *           0  3   7  |  |  |  |    |
 *                     10 13 16 19   24
 */
{
//	char s_day[]="Sun,Mon,Tue,Wed,Thu,Fri,Sat,";
	char s_month[]="Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec,";
	char s[10], *sm_timer, *sm_timer1;
	int i,i1;
   printf("enter WINDOWS_DIFFTIME \n");
   printf("ss_timer=%s@@@\n",ss_timer);
   printf("ss_timer1=%s@@@\n",ss_timer1);
   i=atoi(ss_timer+19);
   i1=atoi(ss_timer1+19);
//   printf("timer_year=%d timer1_year=%d \n",i,i1);
   if(i > i1){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < i1){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
   memcpy(s,ss_timer+4,3);
   s[3]=',';
   s[4]='\0';
//   printf("s_month=%s@@@\n",s);
   if((sm_timer = strstr(s_month,s)) == NULL){
     printf("error sm_timer in WINDOWS_DIFFTIME stop \n");
     exit(5);
   }/*if((sm_timer = strstr(s_month,s)) == NULL){*/
   memcpy(s,ss_timer1+4,3);
   s[3]=',';
   s[4]='\0';
//   printf("s_month=%s@@@\n",s);
   if((sm_timer1 = strstr(s_month,s)) == NULL){
     printf("error sm_timer1 in WINDOWS_DIFFTIME stop \n");
     exit(5);
   }/*if((sm_timer = strstr(s_month,s)) == NULL){*/
   i=sm_timer-sm_timer1;
   if(i > 0){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < 0){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
/*    n day of month     */
   i=atoi(ss_timer+7);
   i1=atoi(ss_timer1+7);
//   printf("timer_nday=%d timer1_nday=%d \n",i,i1);
   if(i > i1){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < i1){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
/*    n hour of day     */
   i=atoi(ss_timer+11);
   i1=atoi(ss_timer1+11);
//   printf("timer_nhour=%d timer1_nhour=%d \n",i,i1);
   if(i > i1){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < i1){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
/*    n minute of hour     */
   i=atoi(ss_timer+14);
   i1=atoi(ss_timer1+14);
//   printf("timer_nminute=%d timer1_nminute=%d \n",i,i1);
   if(i > i1){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < i1){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
/*    n second of minute     */
   i=atoi(ss_timer+17);
   i1=atoi(ss_timer1+17);
//   printf("timer_nseconde=%d timer1_nseconde=%d \n",i,i1);
   if(i > i1){
      *deltat = +1.e+000;
      return;
   }/*if(i > i1){*/
   if(i < i1){
      *deltat = -1.e+000;
      return;
   }/*if(i > i1){*/
/*   times are equal  */
   *deltat = 0.e+000;
}/*  end of WINDOWS_DIFFTIME  */
/*################################################################*/
int EXTR_N_INT(int n,char *s,int i_extracted[])
/*
 *   Extract n int dans *s  
 *   Il n'y a que des int et des blancs en debut de chaine
 *   We return as int the number j   *(s+j) is the character after
 *   the n  int + the blancs
 */
{
int i1,l,j,k;
char s1[101],c;
   
   l=strlen(s);
   j=0;
   i_extracted[0] = 0;
   while(j < l && *(s+j)== ' ')++j;
   c = *(s+j) ;
   if(j > l || ( !isdigit(c) && c != '.' && c != '+' && c != '-'  ))return(j);
      i1=1;
      while(j < l && i1 <= n ){
	 k=0;
	 while(j < l && isdigit(*(s+j))){
	    s1[k]=*(s+j);
	    ++k;
	    ++j;
	 }/*while(j < l && s[j] != ' '){*/
	 s1[k]='\0';
/*	 printf("EXTR_N_INT level 1 j=%d  s1=%s@@@ \n",j,s1);
	 fflush(stdout);*/
	 i_extracted[i1]=atoi(s1);
//		printf("i1=%d s1=%s xx1=%15.8f \n",i1,s1,xx1);
         ++i1;
         while(j < l && *(s+j)== ' ')++j;
/*	 printf("EXTR_N_INT level 2 j=%d   \n",j);
	 fflush(stdout);*/
      }/*for(i1=1;i1 <= n ; ++i1){*/
//      printf("i1 = %d \n",i1);
   i_extracted[0] = i1-1;
   return(j);
}
/*################################################################*/
int EXTR_N_LINT(int n,char *s,long int i_extracted[])
/*
 *   Extract n long int from *s  
 *   Il n'y a que des long int et des blancs en debut de chaine
 *   We return as int the number j   *(s+j) is the character after
 *   the n long int + the blancs
 */
{
int i1,l,j,k;
char s1[101],c;
   
   l=strlen(s);
   j=0;
   i_extracted[0] = 0;
   while(j < l && *(s+j)== ' ')++j;
   c = *(s+j) ;
   if(j > l || ( !isdigit(c) && c != '.' && c != '+' && c != '-'  ))return(j);
      i1=1;
      while(j < l && i1 <= n ){
	 k=0;
	 while(j < l && *(s+j) != ' '){
	    s1[k]=*(s+j);
	    ++k;
	    ++j;
	 }/*while(j < l && s[j] != ' '){*/
	 s1[k]='\0';
	 i_extracted[i1]=atol(s1);
//		printf("i1=%d s1=%s xx1=%15.8f \n",i1,s1,xx1);
         ++i1;
         while(j < l && *(s+j)== ' ')++j;
      }/*for(i1=1;i1 <= n ; ++i1){*/
//      printf("i1 = %d \n",i1);
   i_extracted[0] = i1-1;
   return(j);
}

/**********************************************************************/
long int aln_getline(long int *nc,char **ss,long int *nbytes, FILE *fp)
/*
 *    nbytes is the present memory size for the string ss
 *    returns -2 if EOF
 *    return -1 and nc= NULL if was not able to read in the file
 *    returns tro the number of characters which are in the line
 *    *(*ss+tro)= '\0';
 *    This sub will realloc ss but does not alloc it
 *    It seems that on linux text files we have only a \n character 
 *    at the end of each line
 *    For Windows text files we have \r\n
 *    This sub should read nicely a line on Windows or Linux text files
 *    It should have no problems with Mac files which have only \r
 *    It will return nc
 *    Detection of utf8 lines is automatic. These lines are translated
 *    into Windows latin : CP1252  (with French oe)
 *    On entrance nc is the position to start reading
 *    On output  nc is the position to start next reading
 *    \r = 13  \n = 10
 *    The problem is that on Windows we read \r\n as \n and fgets
 *    is advancing of 2 places. Then there is a difference between
 *    ftell and our counting inc
 *    There is perhaps a problem with empty lines 
 */
{/*=======================================================*/
char c,c1;
long int tro,i,inc, n;
int ok,k,km,iso,utf,ic,ic1,is ;
char *st_line;

/*   printf("enter aln_getline nc=%ld \n",*nc);
   fflush(stdout);*/
   iso = 0 ;
   utf = 0 ;
   tro=-1;
   inc= *nc;
   if(fseek(fp,*nc,0) != 0){ ;// on success it return 0
      nc = NULL;
      **ss = '\0';
      return(tro);
   }//if(fseek(fp,*nc,0)== NULL){ ;
   c=fgetc(fp);
/*   printf("enter aln_getline nc=%ld  c=%d \n",*nc, (int) c);
   fflush(stdout);*/
   if(c == EOF){// for an error or truly end of file
      **ss = '\0';
      tro = -2;
      //  In that case we don't change nc
      return(tro);
   }/*if(c == EOF){*/
   i = 0;
//   while(c != '\0' && c != EOF && c != '\n' && c != NULL){
   if(c == '\n' ){
//      ++inc;
/*      inc = ftell(fp);
      c=fgetc(fp);
      if(c == '\r' )++inc;
      *nc = inc ;
      fseek(fp,*nc,0) ;// go back to position*/
      inc = *nc+1;
      *nc= inc ;
      tro = 0;
      **ss = '\0';
      printf("aln_getline return 10 empty line nc=%ld \n",*nc);
      fflush(stdout);
      return(tro);
   }//if(c == '\n' ){
   if(c == '\r' ){
      while(c == '\r' ){
         inc = ftell(fp);
//      ++inc;
         c=fgetc(fp);
      }//while(c == '\r' ){
      if(c == '\n' )++inc;
      *nc = inc ;
      fseek(fp,*nc,0) ;// go back to position
      tro = 0;
      **ss = '\0';
      printf("aln_getline return 20 empty line nc=%ld \n",*nc);
      fflush(stdout);
      return(tro);
   }//if(c == '\n' ){
   ++inc;
   while( c != EOF && c != '\n' && (int) c != 13){
      is = 1 ;
      if(c == '\t') is = TAB ;
      if(i + is >= *nbytes){
         *nbytes = *nbytes + TAB + 100;
	 n= *nbytes+5;
//	 printf("realloc *nbytes=%ld n=%ld \n",*nbytes,n);
	 *ss = realloc(*ss, n*sizeof(char));
      }/*if(i >= nbytes){*/
      if(c == '\t'){
         for(k = 1 ; k <= TAB ; ++k){
            *(*ss+i) = ' ';
            ++i;
         }//for(k = 1 ; k <= TAB ; ++k){
      }else{//if(c == '\t'){
         if( c != '\0') {//13 is \r  character on a windows text file
//  The '\0' character should not be on a text file but...
            *(*ss+i) = c;
            ++i;
         }/*if(c != 13) {*/
      }//if(c == '\t'){
      ic = (int) c; if(ic < 0)ic = ic+256;
/*      printf("aln_getline inc=%ld c=%c  ic=%d \n",inc,c,ic);
      fflush(stdout);*/

      km = 0;
      if(ic >= 192){
         if( ic < 224){
	    km = 1 ;
         }else{//if( c < 224){
	    if(ic < 240){
	       km = 2 ;
	    }else{//if(c < 240){
	       if(ic < 248){
	          km = 3 ;
	       }else{//if(c < 240){
	          km = 0 ;
		  iso = 1 ;
	       }//if(c < 240){
	    }//if(c < 240){
         }//if( ic < 224){
      }//if(c >= 192){
      c=fgetc(fp);
      ++inc;
/*      printf("next inc=%ld c=%c  ic=%d km=%d \n",inc,c, (int) c,km);
      fflush(stdout);*/
      if(km > 0){
/*       printf("aln_getline km=%d ic1=%d c=%c@@@ \n",km, (int) c , c);
         fflush(stdout);*/
         k = 1 ;
	 ok = 1;
         while(ok == 1 && c != '\0' && c != EOF && c != 10 && c != 13 && k <= km){
            if( c != '\0') {//13 is \r  character on a windows text file
//           The '\0' character should not be on a text file but...
               *(*ss+i) = c;
               ++i;
            }/*if(c != 13) {*/
            ic = (int) c; if(ic < 0)ic = ic+256;
/*          printf("k=%d c=%c  ic=%d \n",k,c,ic);
            fflush(stdout);*/
	    if(!(ic >= 128 && ic < 192))ok = 0;
	    ++k ;
            c=fgetc(fp);
	    ++inc;
         }//while(c != '\0' && c != EOF && k <= km){
	 if(k <= km)ok = 0;
	 if(ok == 0){
	    iso = 1;
	 }else{//if(ok == 0){
	    utf = 1;
	 }//if(ok == 0){
      }//if(km > 0){

   }/*while(c != '\0' && c != EOF ){*/
/*  printf("aln_getline out of while inc=%ld iso=%d  utf8=%d \n \n",inc,iso,utf);
            fflush(stdout);*/
   if( utf == 1){
      if(iso == 1){
         *(*ss+i)= '\0';
         printf("aln_getline bad mixture of iso and utf8 \n ss=%s@@@\n",*ss);
            fflush(stdout);
      }else{//if(iso == 1){
         *(*ss+i)= '\0';
/*         printf("aln_getline  utf=1 ss=%s@@@\n",*ss);
            fflush(stdout);*/
//         st_line = g_convert(*ss,-1,"ISO-8859-15","UTF-8",NULL,NULL,NULL);
         st_line = g_convert(*ss,-1,"CP1252","UTF-8",NULL,NULL,NULL);
/*         printf("aln_getline  st_line=%s@@@\n",st_line);
            fflush(stdout);*/
	 if(st_line != NULL){
	    strcpy(*ss,st_line);
	    g_free(st_line);
	 }else{//if(st_line != NULL){
//	    strcpy(*ss,"???? !!! ");
	 }//if(st_line != NULL){
/*         printf("aln_getline  utf8 line \n ss=%s@@@\n",*ss);
            fflush(stdout);*/
	 i= strlen(*ss);
      }//if(iso == 1){
   }else{//if( utf == 1){
      *(*ss+i)= '\0';
//      printf("aln_getline  iso line \n ss=%s@@@\n",*ss);
   }//if( utf == 1){
//   ncm = ftell(fp);
/*      printf("alngetline level 1 inc=%ld ftell=%ld c=%c  ic=%d  \n",inc,ftell(fp),c, (int) c);
      fflush(stdout);*/
   tro = i ;
   *(*ss+i)= '\0';
//   inc=ftell(fp);/** This is necessary for Windows reading  **/
   ic = (int )c;
/* printf("output aln_getline inc=%ld ic=%d ss=%s@@@@\n",inc,(int)c,*ss);
   fflush(stdout);*/
//   printf("output aln_getline ss=%s@@@ \n",*ss);
#if LINUX
   if(ic == 13 ){
      ic1 = 13;
      while(ic1 == 13){
         fseek(fp,inc,0);
         c1 = fgetc(fp);
         ic1 = (int )c1;
	 ++inc;
      }//while(ic1 == 13){
/*         printf("aln_getline linux  return 1 ic1=%d @@@ \n",ic1);
         fflush(stdout);*/
      if( ic1 == 10 ){
         *nc = inc;
/*         printf("aln_getline linux  return  nc=%ld ss=%s@@@ \n",*nc,*ss);
         fflush(stdout);*/
         return(tro);
      }//if( ic1 == 10 ){
   }//if( ic == 13 ){
#endif
#if WINDOWS
   if(ic == 10 ){
   int ncm;
      ncm = inc;
      --inc;
      fseek(fp,inc,0);
      c1 = fgetc(fp);
      ic1 = (int )c1;
  //     printf("aln_getline windows  return nc_dep=%ld ncm=%ld ic1=%d \n",*nc,ncm,ic1);
      if( ic1 == 10 ){
         *nc = ncm+1;
         printf("aln_getline windows  return 1 nc=%ld ss=%s@@@ \n",*nc,*ss);
         return(tro);
      }//if( ic1 == 10 ){
         *nc = ncm;
 //     printf("aln_getline windows  return 2 nc=%ld ss=%s@@@ \n",*nc,*ss);
         return(tro);
   }//if(ic == 10 ){
#endif
//  printf("aln_getline return direct nc=%ld ss=%s@@@ \n",*nc,*ss);

/*    printf("aln_getline return 3 nc=%ld ss=%s@@@ \n",*nc,*ss);
      fflush(stdout);*/
   *nc = inc;
   return(tro);
}/*=======================================================*/

/*################################################################*/
   char *RM_PATH_FROM_STRING(char path[])
/*
 *    On output this function gives the filename 
 *    extracted from the path which is in a character string
 */
 {
    int l,i,j,ll;
    char *s ;

    l = strlen(path);
//    printf("path=%s@@@@  path[l-1]=%c \n",path,path[l-1]);
    if(l <= 0 ) return(NULL);
    j = l-1 ;
    while( j >= 0 && path[j] != '/')--j;
    ll=l-j+4;
    s = g_malloc( ll*sizeof (char));
  /*  s = malloc( sizeof (char) * (l+1));*/
    i= 0 ;
    if(j < 0){
       strcpy(s,"./");
       i=2;
    }/*if(j < 0){*/
    strcpy(s,"&/");
    i=2;
    for (j = j+1  ; j <= l ; ++j){
       s[i] = path[j];
       ++i ;
    }/* end of for (j ; j <= l ; ++j){*/
    s[i] = '\0';
//    printf("in RM_PATH_FROM_STRING s=%s@@@ \n",s);
    if(i+1 > ll){
       printf("in RM_PATH_FROM_STRING error mem STOP \n");
       exit(90);
    }/*if(i+1 > ll){*/
    return(s);
 }/* end of  char *filename_from_path(char path[])*/
/*################################################################*/
   char *PATH_FROM_STRING(char *string)
/*
 *    On output this function gives the path 
 *    extracted from the character string
 *    which is the full path+file_name
 */
 {
    int l,i,j,j1,k,ll;
    char *s,c ;

    l = strlen(string);
    j1 = 0;
    while(j1 < l && *(string+j1) == ' ')++j1;
//    printf("string=%s@@@@  string[l-1]=%c \n",string,string[l-1]);
    if(l <= 0 ) return(NULL);
    j = l-1 ;
    while( j >= 0 && (c = *(string+j)) != '/' &&  c != '\\')--j;
    ll=j+4;
    s = g_malloc( ll*sizeof (char));
  /*  s = malloc( sizeof (char) * (l+1));*/
    if(j < j1){
       strcpy(s,"./");
       return(s);
    }/*if(j < 0){*/
    i= 0 ;
    c = *(string+j1);
    if( c != '.' && c != '/' && c != '\\' \
                  && !(isupper(c) && *(string+j1+1) == ':')  ){
       strcpy(s,"./");
       i = 2 ;
    }//if( c != '.' && c != '/' && c != '\\'  ){
    k = j1;
    while (  k <= j ){
       c = *(string+k);
       if(c == '\\')c= '/';
       *(s+i) = c;
       ++i;
       ++k;
    }/* end of for (j ; j <= l ; ++j){*/
    s[i] = '\0';
    printf("in PATH_FROM_STRING string=%s@@@ path=%s@@@ \n",string,s);
    return(s);
 }/* end of  char *filename_from_path(char path[])*/
/*################################################################*/
   char *FILE_NAME_FROM_STRING(char *string)
/*
 *    On output this function gives the filename 
 *    extracted from the full path which is in a character string
 */
 {
    int l,i,j,ll;
    char *s,c ;

    l = strlen(string);
//    printf("path=%s@@@@  path[l-1]=%c \n",path,path[l-1]);
    if(l <= 0 ) return(NULL);
    j = l-1 ;
    while( j >= 0 && (c = *(string+j)) != '/' &&  c != '\\')--j;
    ll=l-j+4;
    s = g_malloc( ll*sizeof (char));
  /*  s = malloc( sizeof (char) * (l+1));*/
    i= 0 ;
    for (j = j+1  ; j <= l ; ++j){
       c = *(string+j);
       if(c == '\\')c= '/';
       *(s+i) = c;
       ++i ;
    }/* end of for (j ; j <= l ; ++j){*/
    *(s+i) = '\0';
//    printf("in RM_PATH_FROM_STRING s=%s@@@ \n",s);
//    printf("in FILE_NAME_FROM_STRING string=%s@@@ file_name=%s@@@ \n",string,s);
    return(s);
 }/* end of  char *filename_from_path(char path[])*/
/*################################################################*/
void  RM_EXTRA_BLANCS(char *s)
/*
 *    in string s  no more than 1 blanc in a pack of blancs
 *    example   word1   word2 word3   becomes
 *              word1 word2 word3
 *    You can have blancs before word1 and after word3
 *    they will be reduced if necessary to 1 unit.
 */
{ /*  begins RM_EXTRA_BLANCS */
   int i,j,l;

// printf("input  RM_EXTRA_BLANCS s=%s@@@\n",s);
   j= 0;
   i= 0;
   l= strlen(s);
   if(*(s) == ' '){
      ++j;
      while(*(s+i) == ' ')++i;
   }/* end if(s[0] == ' '){  */
   while(i < l){
//      printf("loop while 1 s=%s@@@ \n",s);
      while(i<l && *(s+i) != ' '){
//	 printf("i=%d *(s+i)=%c \n",i,*(s+i));
	 *(s+j) = *(s+i) ;
	 ++j;
	 ++i;
      }/* while(i<l && s[i] != ' '){*/
// printf("level 1RM_EXTRA_BLANCS s=%s@@@\n",s);
      
      if(i < l && *(s+i) == ' '){
	 ++i;
	 *(s+j) = ' ';
	 ++j;
	 while(i < l && s[i] == ' ')++i;
      }/*  end if(i , l && s[i] == ' '){*/
   }/*while(i < l){*/
   *(s+j) = '\0';
// printf("output RM_EXTRA_BLANCS s=%s@@@\n",s);
} /*  ends RM_EXTRA_BLANCS */
/*################################################################*/
void  RM_ALL_BLANCS(char *s)
/*
 *    in string s  all blancs are removes
 *    example   word1   word2 word3   becomes
 *              word1word2word3
 */
{ /*  begins RM_ALL_BLANCS */
   int i,j,l;

// printf("input  RM_EXTRA_BLANCS s=%s@@@\n",s);
   j= 0;
   i= 0;
   l= strlen(s);
      while(i<l && *(s+i) != ' '){
//	 printf("i=%d *(s+i)=%c \n",i,*(s+i));
	 *(s+j) = *(s+i) ;
	 ++j;
	 ++i;
      }/* while(i<l && s[i] != ' '){*/
   *(s+j) = '\0';
// printf("output RM_ALL_BLANCS s=%s@@@\n",s);
} /*  ends RM_ALL_BLANCS */
/*################################################################*/
void  LNB_12CHAR(long int nb,char *snb)
/*
 *    Writes a long integer into 12 characters
 */
{//============  start LNB_12CHAR  ========================
char sw[26];
int i,j,l,dd;
/*   printf("enter LNB_12CHAR nb=%ld   \n",nb);
   fflush(stdout);*/
   sprintf(sw,"%ld",nb);
/*   printf("LNB_12CHAR sw=%s@@@@   \n",sw);
   fflush(stdout);*/
   l=strlen(sw);
   dd=(12-l)/2;
/*   printf("LNB_12CHAR dd=%d   \n",dd);
   fflush(stdout);*/
   if(dd < 0){
      printf("Warning LNB_12CHAR sw=%s@@@\n",sw);
      sw[12]='\0';
      dd=0;
      l=12;
   }//if(dd < 0){
   j=0;
   for(i = 0 ; i < dd ; ++i){
     *(snb+j) = ' ';
     ++j;
   }//for(i = 0 ; i < dd ; ++i){
   *(snb+j) = '\0';
/*   printf("LNB_12CHAR level 1 snb=%s@@@@   \n",snb);
   fflush(stdout);*/
   i=0;
   for(i=0 ;i < l ; ++i ){
     *(snb+j) = sw[i];
     ++j;
   }//while(i < l){
   while(j < 12){
     *(snb+j) = ' ';
     ++j;
   }//while(i < l){
   j=13;
   *(snb+j) = '\0';
/*   printf("LNB_12CHAR nb=%ld  snb=%s@@@@ \n",nb,snb);
   fflush(stdout);*/
}//============  start LNB_12CHAR  ========================
/*################################################################*/
long int  DIFF_JOUR()
/*
 * Calcul du nombre de jours depuis le 1er janvier 2001
 */
/*
time_t timer;
struct tm t_local;
      timer = time(NULL);
      t_local = *localtime(&timer);
      int yy = (t_local).tm_year+1900;
      sprintf(s_bmp,"E:\\Dev-Cpp\\kuzhet\\sk%4d%2d%2d_%2d%2d%2d.jpeg",yy,\
          t_local.tm_mon+1,t_local.tm_mday,t_local.tm_hour,\
	  t_local.tm_min,t_local.tm_sec);*/
{//==========   Start   DIFF_JOUR  ===========================
     time_t  timer;
     struct tm ptime;
     int an,ms,jr;
     double njul, cjul ;
     long int  diff_jour;

        timer = time(NULL) ;// present time
	ptime = *localtime(&timer);
	an = 1900 + ptime.tm_year ;
	ms = 1 + ptime.tm_mon;
	jr = ptime.tm_mday ;
	njul = Julien(an,ms,jr);
/*
 *   calcul du jour julien du 21 eme siecle (1 janvier 2001)
 */
       an = 2001 ;
       ms = 1 ;
       jr = 1;
       cjul = Julien(an,ms,jr);
       diff_jour = njul-cjul;
       return(diff_jour);
       
}//==========   END   DIFF_JOUR  ===========================
/*################################################################*/
    //--------------------------------------------------------------------
    double Julien(int an, int ms, int jr)
    {
      // Returne le nombre de jours Juliens
      double jd;
      jd = (1461 * (an + 4800 + (ms -14) / 12)) / 4;
      jd += (367 * (ms - 2 - 12 * ((ms - 14) / 12))) / 12;
      jd -= (3 * ((an + 4900 + (ms - 14) / 12) / 100)) / 4;
      jd += jr;
      return jd;
    }
   //----------------------------------------------------------------------
/*################################################################*/
  
   double Julian(int year,int month,double day)
   {
     // Returns the number of julian days for the specified day.
  
       int a,b,c,e;
       if (month < 3) {
          year--;
          month += 12;
       }
       if (year > 1582 || (year == 1582 && month>10) ||\
           (year == 1582 && month==10 && day > 15)) {
          a=year/100;
          b=2-a+a/4;
       }
       c = 365.25*year;
       e = 30.6001*(month+1);
       return b+c+e+day+1720994.5;
   }
   //---------------------------------------------------------------------------
/*################################################################*/
/*********************************************************************
 *
 * Purpose: Demonstrate the 'srand' and 'rand' functions
 * Author:  M.J. Leslie.
 * Date:    11=Nov-94
 *
 *********************************************************************/
/*
#include <time.h>
#include <stdlib.h>

main()
{
  int rolls=4;*/
					/* This looks DISCUSTING!
					 * time returns a different value 
					 * on every execution. And so 
					 * changes the value passed to 
					 * srand. See CAST
					 * for an explanation of 
					 * (unsigned int) and (time_t)	*/
  //srand((unsigned int)time((time_t *)NULL));

					/* Roll the dice.		*/
 /* while(rolls--)
  {
    printf("Dice value is %d\n", (rand()%6)+1);
  }
}
*/
/*##################################################################*/
void  RESIZE_STRING(int lssd, char *ss)
/*
 *    Resizing of the string ss, adding or removing blancs
 * ss is a string of the kind :
 *        1      ;     1      ;    3244    ;     0      ;     0      ;    3244    ;
 */
{//==========Start of RESIZE_STRING===============================
 int i,j,k,kk,l ;
 int iblanc;
    l= strlen(ss);
    if(l == lssd)return;
    if(lssd > l){
       for(i = l ; i < lssd ; ++i)*(ss+i)=' ';
       *(ss+lssd)= '\0';
       return;
    }//if(lssd > l){
/*
 *   Here we have the difficult case lssd < l
 *   we must remove blancs in ss but still let
 *   a single blanc as separator before and after the non blancs
 *   characters
 */
   kk = l -lssd ;
   i = 0 ;
   j = 0 ;
   k = 0;
   iblanc = 0;
   while(i < l && k < kk){
      if(*(ss+i) != ' '){
         iblanc = 0 ;
	 if(j != i)*(ss + j) = *(ss+i);
	 ++j ;
      }else{//if(*(ss+i) != ' '){
          if(iblanc == 1){
	     ++k;
          }else{//if(iblanc == 1){
	     if(j != i)*(ss + j) = *(ss+i);
	     ++j ;
          }//if(iblanc == 1){
	  iblanc = 1;
      }//if(*(ss+i) != ' '){
      ++i;
   }//while(i >= 0 && k < j){
   while(i < l && j < lssd ){
      if(j != i)*(ss + j) = *(ss+i);
      ++j ;
      ++i;
   }//while(i < l){
   if(j != lssd){
      printf("error RESIZE_STRING j=%d lssd=%d \n",j,lssd);
   }//if(j != lssd){
   *(ss+lssd) = '\0';
}//==========End of RESIZE_STRING=================================
/*################################################################*/
/*    Il n'existe pas en C de fonction réalisant la copie d'un fichier. 
 *    Il est donc nécessaire de créer une fonction lisant le fichier
 *    pour le copier dans le fichier de destination.
 *    trouve dans
 *    http://c.developpez.com/faq/?page=fichiers#FICHIERS_sup_ligne

#include <stdio.h>
          return 0    copie ok
	  return 1    pas de fichier source
	  return 2    impossible ouvrir le fichier destination
*/
int copier_fichier(char const * const source, char const * const destination)
{
    FILE* fSrc;
    FILE* fDest;
    char buffer[512];
    int NbLus;
    
    if ((fSrc = fopen(source, "rb")) == NULL)
    {
        return 1;
    }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
    {
        fclose(fSrc);
        return 2;
    }
    
    while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0)
        fwrite(buffer, 1, NbLus, fDest);
    
    fclose(fDest);
    fclose(fSrc);
    
    return 0;
}

/*################################################################*/
/*    
 *    This sub will transform a .txt file into a file which
 *    can be read by gcc on MS-Windows.
 *    Any \r will be followed by \n
 *    Any \n will be preceeded by \r
 *    There is no other code-transform of the file.
 *
 *    \r = 13  \n = 10
 *    For unknown reasons, it seems that we have many \r\r\n

#include <stdio.h>
          return 0    copie ok
	  return -1    pas de fichier source
	  return -2    impossible ouvrir le fichier destination
	  return modif  nombre de modifs dans le fichier
*/
int smpl_win_file(char const * const source, char const * const destination)
{
    FILE* fSrc;
    FILE* fDest;
//    char c,buffer[512],bfr[3],bfn[3];
    char c,buffer[515],bfr[3],bfn[3];
    int i,i0,ibfn,NbLus,Nb,modif;
    
    if ((fSrc = fopen(source, "rb")) == NULL)
    {
        return -1;
    }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
    {
        fclose(fSrc);
        return -2;
    }
    modif = 0;
    bfr[0]= '\r';
    bfn[0]= '\n';
    ibfn = 0;
    while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
        buffer[NbLus] = '\0';
	printf("win_file buffer=%s@@@ \n",buffer);
	i0 = 0;
	while(i0 < NbLus){
	   i = i0;
	   while(i < NbLus && (c = buffer[i]) != '\r' && c != '\n')++i;
	   printf("win_file i0=%d i=%d ic=%d \n",i0,i,(int) c);
	   if(ibfn == 1){
              if(buffer[i0] != '\n'){
	         fwrite(bfn, 1, 1, fDest);
		 ++modif;
              }//if(buffer[i0] != '\n'){
	      ibfn = 0;
	   }//if(ibfn == 1){
	   Nb = i -i0 ;
	   if(i >= NbLus){
              fwrite(buffer+i0, 1, Nb, fDest);
	      i0 = NbLus;//this terminates : while(i0 < NbLus){
	      continue;
	   }//if(i >= NbLus){
           fwrite(buffer+i0, 1, Nb, fDest);
	   if(c == '\n'){
	       ++modif;
//??	       fwrite(bfr, 1, 1, fDest);
	       fwrite(bfn, 1, 1, fDest);
	       i0 = i+1;
	       continue;
	   }//if(c = '\n'){
	   //  at that level c = \r
//??	   fwrite(bfr, 1, 1, fDest);
	   ibfn = 1;
	   i0 = i+1;
	   if(i0 < NbLus && buffer[i0] == '\r')++i0;
	}//while(i0 < NbLus){
    }//while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
    
    fclose(fDest);
    fclose(fSrc);
    
    return modif;
}

/*################################################################*/
/*    
 *    This sub will transform a .txt file into a file which
 *    can be read by gcc on MS-Windows.
 *    Any \r will be followed by \n
 *    Any \n will be preceeded by \r
 *    There is no other code-transform of the file.
 *

#include <stdio.h>
          return 0    copie ok
	  return -1    pas de fichier source
	  return -2    impossible ouvrir le fichier destination
	  return modif  nombre de modifs dans le fichier
*/
int old_win_file(char const * const source, char const * const destination)
{
    FILE* fSrc;
    FILE* fDest;
    char c,buffer[512],bfr[3],bfn[3];
    int i,i0,ibfn,NbLus,Nb,modif;
    
    if ((fSrc = fopen(source, "rb")) == NULL)
    {
        return -1;
    }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
    {
        fclose(fSrc);
        return -2;
    }
    modif = 0;
    bfr[0]= '\r';
    bfn[0]= '\n';
    ibfn = 0;
    while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
	i0 = 0;
	while(i0 < NbLus){
	   i = i0;
	   while(i < NbLus && (c = buffer[i]) != '\r' && c != '\n')++i;
//	   printf("winfile i0=%d i=%d ic=%d \n",i0,i,(int) c);
	   if(ibfn == 1){
              if(buffer[i0] != '\n'){
	         fwrite(bfn, 1, 1, fDest);
		 ++modif;
              }//if(buffer[i0] != '\n'){
	      ibfn = 0;
	   }//if(ibfn == 1){
	   Nb = i -i0 ;
	   if(i >= NbLus){
              fwrite(buffer+i0, 1, Nb, fDest);
	      i0 = NbLus;//this terminates : while(i0 < NbLus){
	      continue;
	   }//if(i >= NbLus){
           fwrite(buffer+i0, 1, Nb, fDest);
	   if(c == '\n'){
	       ++modif;
	       fwrite(bfr, 1, 1, fDest);
	       fwrite(bfn, 1, 1, fDest);
	       i0 = i+1;
	       continue;
	   }//if(c = '\n'){
	   //  at that level c = \r
	   fwrite(bfr, 1, 1, fDest);
	   ibfn = 1;
	   i0 = i+1;
	}//while(i0 < NbLus){
    }//while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
    
    fclose(fDest);
    fclose(fSrc);
    
    return modif;
}

/*################################################################*/
/*    
 *    This sub will transform a .txt file into a file which
 *    can be read by gcc on MS-Windows.
 *    Any \r will be followed by \n
 *    Any \n will be preceeded by \r
 *    The input file can be in utf8. It will be transformed
 *    in CP1252  readable by Windows
 *

#include <stdio.h>
          return 0    copie ok
	  return -1    pas de fichier source
	  return -2    impossible ouvrir le fichier destination
	  return modif  nombre de modifs dans le fichier
*/
int win_file(char const * const source, char const * const destination)
{
    FILE* fSrc;
    FILE* fDest;
    char c,buffer[515],bfr[3],bfn[3];
    char ss1[520], *ss;
    int i,i0,ibfn,NbLus,Nb,modif;
    int ok, iso,utf;
    int k,km,ic,iss1 ;
    
    if ((fSrc = fopen(source, "rb")) == NULL)
    {
        return -1;
    }
    
    if ((fDest = fopen(destination, "wb")) == NULL)
    {
        fclose(fSrc);
        return -2;
    }
    modif = 0;
    bfr[0]= '\r';
    bfn[0]= '\n';
    ibfn = 0;
    km = 0;
    while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
        buffer[NbLus] = '\0';
	printf("win_file buffer=%s@@@ \n",buffer);
	i0 = 0;
/*
 *    we must terminate the preceeding buffer
 */
	if(km > 0){
	printf("win_file km=%d \n",km);
	   ok = 1;
	   while(i0 < NbLus && ok == 1 && k <= km \
	      && (c = buffer[i0]) != '\0' && c != '\r' && c != '\n'){
	      ++i0;
              ic = (int) c; if(ic < 0)ic = ic+256;
	      if(!(ic >= 128 && ic < 192))ok = 0;
	      ss1[iss1]= c;
	      ++iss1;
	      ++k ;
	   }//while(i0 < NbLus && ok == 1 && k <= km 
	   if(k <= km){
	      iso = 1;
	   }else{//if(k <= km){
	      utf = 1;
	   }//if(k <= km){
           if( utf == 1){
              if(iso == 1){
                 ss1[iss1]= '\0';
         printf("win_file 1 bad mixture of iso and utf8 \n ss=%s@@@\n",ss1);
            fflush(stdout);
              }else{//if(iso == 1){
                 ss1[iss1]= '\0';
                 ++modif;
                 ss = g_convert(ss1,-1,"CP1252","UTF-8",NULL,NULL,NULL);
	         if(ss != NULL){
	            strcpy(ss1,ss);
	            g_free(ss);
	         }else{//if(st_line != NULL){
	            strcpy(ss1,"error ???? !!! ");
	         }//if(st_line != NULL){
         printf("win_file  utf8 line \n ss1=%s@@@\n",ss1);
            fflush(stdout);
	         iss1= strlen(ss1);
              }//if(iso == 1){
           }else{//if( utf == 1){
              ss1[iss1]= '\0';
      printf("win_file line \n ss1=%s@@@\n",ss1);
           }//if( utf == 1){
	   fwrite(ss1, 1, iss1, fDest);
	   km = 0;
	   iss1 = 0;
	}//if(km > 0){
/*
 *    End termination of the preceeding buffer
 */
	while(i0 < NbLus){
	   iso = 0;
	   utf = 0;
	   i = i0;
	   while(i < NbLus && (c = buffer[i]) != '\r' && c != '\n'){
	//   printf("win_file i0=%d i=%d ic=%d \n",i0,i,(int) c);
	      iss1 = i-i0;
	      ss1[iss1] = c;
              ic = (int) c; if(ic < 0)ic = ic+256;
              km = 0;
              if(ic >= 192){
                 if( ic < 224){
	            km = 1 ;
                 }else{//if( c < 224){
	            if(ic < 240){
	               km = 2 ;
	            }else{//if(c < 240){
	               if(ic < 248){
	                  km = 3 ;
	               }else{//if(c < 240){
	                  km = 0 ;
		          iso = 1 ;
	               }//if(c < 240){
	            }//if(c < 240){
                 }//if( ic < 224){
              }//if(c >= 192){
	      ++i;
	      ++iss1;
	      if(km > 0){
	     //?a    ++iss1;
	         ok = 1;
		 k = 1;
	         while(i < NbLus && ok == 1 && k <= km \
	            && (c = buffer[i]) != '\0' && c != '\r' && c != '\n'){
	            ++i;
                    ic = (int) c; if(ic < 0)ic = ic+256;
	            if(!(ic >= 128 && ic < 192))ok = 0;
	            ss1[iss1]= c;
	            ++iss1;
	            ++k ;
	         }//while(i0 < NbLus && ok == 1 && k <= km 
	         if(k <= km){
	            if(i < NbLus){
		       k=km+1;//that will terminate the expected char
		       iso = 1;
	            }//if(i < NbLus){
	         }else{//if(k <= km){
	            utf = 1;
	         }//if(k <= km){
	      }//if(km > 0){
	   }//while(i < NbLus && (c = buffer[i]) != '\r'...

	    ss1[iss1]= '\0';
//	   printf("winfile i0=%d i=%d ic=%d \n",i0,i,(int) c);
	   if(ibfn == 1){
              if(buffer[i0] != '\n'){
	         fwrite(bfn, 1, 1, fDest);
		 ++modif;
              }//if(buffer[i0] != '\n'){
	      ibfn = 0;
	   }//if(ibfn == 1){
	   Nb = i -i0 ;
	   if(i >= NbLus){
	      if(km == 0 || k > km){
	         if(utf == 1){
		    if(iso == 1){
            printf("win_file 2 bad mixture of iso and utf in ss1=%s@@@ \n",\
		            ss1);
		    }//if(utf == 1){
                    ++modif;
                    ss = g_convert(ss1,-1,"CP1252","UTF-8",NULL,NULL,NULL);
	            if(ss != NULL){
	               strcpy(ss1,ss);
	               g_free(ss);
	            }//if(st_line != NULL){
	            iss1= strlen(ss1);
	            fwrite(ss1, 1, iss1, fDest);
	         }else{//if(utf == 1){
//    At that level, we should have iso = 1 and utf = 0
                    fwrite(buffer+i0, 1, Nb, fDest);
	         }//if(utf == 1){
	         km = 0;
		 iss1= 0;
		 iso = 0;
		 utf=0;
//?????????????????????????????????????????????????
	      }//if(k > km){
//  at that level we must continue on the next buffer
	      i0 = NbLus;//this terminates : while(i0 < NbLus){
	      continue;
	   }//if(i >= NbLus){
//*******   start writing line 
//At that level, we must write the line, disregarding the values of 
//   k and km
//           fwrite(buffer+i0, 1, Nb, fDest);
		 ss1[iss1] = '\0';
	         if(utf == 1){
		    if(iso == 1){
            printf("win_file 3 bad mixture of iso and utf in ss1=%s@@@ \n",\
		            ss1);
		    }//if(utf == 1){
                    ++modif;
                    ss = g_convert(ss1,-1,"CP1252","UTF-8",NULL,NULL,NULL);
	            if(ss != NULL){
	               strcpy(ss1,ss);
	               g_free(ss);
	            }//if(st_line != NULL){
	            iss1= strlen(ss1);
            printf("win_file 3  ss1=%s@@@ \n",ss1);
	            fwrite(ss1, 1, iss1, fDest);
	         }else{//if(utf == 1){
//    At that level, we should have iso = 1 and utf = 0
                    fwrite(buffer+i0, 1, Nb, fDest);
	         }//if(utf == 1){
	         km = 0;
	         iss1 = 0;
		 iso=0;
		 utf = 0;
//*******   end writing line 
	   if(c == '\n'){
	       ++modif;
    fwrite(bfr, 1, 1, fDest);
	       fwrite(bfn, 1, 1, fDest);
	       i0 = i+1;
	       continue;
	   }//if(c = '\n'){
	   //  at that level c = \r
//??	   fwrite(bfr, 1, 1, fDest);
    fwrite(bfr, 1, 1, fDest);
	   ibfn = 1;
	   i0 = i+1;
	   if(i0 < NbLus && buffer[i0] == '\r')++i0;
	}//while(i0 < NbLus){
    }//while ((NbLus = fread(buffer, 1, 512, fSrc)) != 0){
    
    fclose(fDest);
    fclose(fSrc);
    
    return modif;
}

/*################################################################*/
/*
 *   Pour supprimer un fichier
 Sous Windows, à l'aide de DeleteFile (inclure windows.h) 
 et sous UNIX (et plus généralement n'importe quel système se 
 conformant à la norme POSIX), à l'aide de la fonction unlink
 (déclarée dans unistd.h). La bibliothèque standard du C fournit
 également une fonction qui sait remplir cette tâche qui n'est autre 
 que remove (déclarée dans stdio.h).

#include <stdio.h>

int remove(const char * pathname);
*/
/*################################################################*/
char *back_up_file(char *file_path)
/*
 *    input a full path for a file : file_path
 *    examples : /home/toto/file_name   ./file_name    .....
 *    This sub make a copy in :  /home/toto/cpy_file_name
 *                         or :  ./cpy_file_name
 *
 */
 {
    char *ss_cpy,*ss;
    int rtn;
    int l;
       l= strlen(file_path);
       ss_cpy = g_malloc((l+15)*sizeof(char));
//
       ss = PATH_FROM_STRING(file_path);
       strcpy(ss_cpy,ss);
       g_free(ss);
       strcat(ss_cpy,"cpy_");
       ss = FILE_NAME_FROM_STRING(file_path);
       strcat(ss_cpy,ss);
       printf("back_up_file=%s \n",ss_cpy);
       fflush(stdout);
       g_free(ss);
       rtn = copier_fichier(file_path,ss_cpy);
//       g_free(ss_cpy);
       if(rtn != 0)ss_cpy = NULL;
       printf("out of back_up_file \n");
       fflush(stdout);
       return(ss_cpy);
 }
/*################################################################*/
